ARG BUILD_ARG_UBUNTU_VERSION="24.04"
ARG BUILD_ARG_APP_GROUP_ID="65532"
ARG BUILD_ARG_APP_USER_ID="65532"

FROM ubuntu:${BUILD_ARG_UBUNTU_VERSION} AS ubuntu
ARG BUILD_ARG_UBUNTU_VERSION
ENV HISTFILE="/dev/null"
ENV TZ="UTC"
COPY ./images/rabbitmq/stages/ubuntu/ /

FROM ubuntu AS rabbitmq-skeleton
ARG BUILD_ARG_APP_GROUP_ID
ARG BUILD_ARG_APP_USER_ID
COPY ./images/rabbitmq/stages/rabbitmq-skeleton/ /
RUN /build.d/bin/install

FROM rabbitmq-skeleton AS rabbitmq-server
ARG BUILD_ARG_APP_GROUP_ID
ARG BUILD_ARG_APP_USER_ID
RUN /build.d/bin/commit
ENTRYPOINT ["/usr/lib/rabbitmq/bin/rabbitmq-server"]
USER ${BUILD_ARG_APP_USER_ID}:${BUILD_ARG_APP_GROUP_ID}
VOLUME ["/var/lib/rabbitmq/"]

FROM rabbitmq-skeleton AS rabbitmq-server-tls-initializer
ARG BUILD_ARG_APP_GROUP_ID
ARG BUILD_ARG_APP_USER_ID
COPY ./images/rabbitmq/stages/rabbitmq-server-tls-initializer/ /
RUN /build.d/bin/install
RUN /build.d/bin/commit
ENTRYPOINT ["/entrypoint.sh"]
USER ${BUILD_ARG_APP_USER_ID}:${BUILD_ARG_APP_GROUP_ID}
VOLUME ["/etc/rabbitmq/tls/"]

FROM rabbitmq-skeleton AS rabbitmq-server-tls-watcher
ARG BUILD_ARG_APP_GROUP_ID
ARG BUILD_ARG_APP_USER_ID
COPY ./images/rabbitmq/stages/rabbitmq-server-tls-watcher/ /
RUN /build.d/bin/install
RUN /build.d/bin/commit
ENTRYPOINT ["/entrypoint.sh"]
USER ${BUILD_ARG_APP_USER_ID}:${BUILD_ARG_APP_GROUP_ID}
VOLUME ["/etc/rabbitmq/tls/"]
